<?
/**************************************************************************
*   PHP DateValidator v1.0                                                *
*   Copyright (C) 2005 by Brent Kelly                                     *
*   glitch13@glitch13.com                                                 *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************
Example:
	$sDate = "12.2/04"; //Example of crappily formatted date	
	$obDateValidator = new CDateValidator;
	$bResult = $obDateValidator->Validate($sDate);
	if ( !$bResult ) {
		echo "Error in DateValidator: '".$obDateValidator->GetError()."'.";
	} else {
		echo $obDateValidator->GetFormattedDate();
	}
	$obDateValidator = NULL;
*/	

Class CDateValidator {

	var $m_sFormattedDate;
	var $m_sError;
	
	function CDateValidator() {
	}

	function GetFormattedDate(){
		return($this->m_sFormattedDate);
	}
	function SetFormatedDate($aryDate, $sFormat){
		
		$sDate = $this->PadSingleDigits($this->GetMonth($aryDate, $sFormat))."/".$this->PadSingleDigits($this->GetDay($aryDate, $sFormat))."/".$this->GuessCentury($this->GetYear($aryDate, $sFormat));
		$this->m_sFormattedDate = $sDate;
	}
	function SetError($sError) {
		$this->m_sError = $sError;
	}
	function GetError() {
		return($this->m_sError);
	}

	function Validate($date){

		$tmpdate = $date;

		$aryFormat = array();

		//Possible date formats
		$aryFormat[] = "m-d-Y";
		$aryFormat[] = "m-d-y";
		$aryFormat[] = "Y-m-d";
		$aryFormat[] = "m-y-d";
		$aryFormat[] = "m-Y-d";
		$aryFormat[] = "d-m-y";
		$aryFormat[] = "d-y-m";
		$aryFormat[] = "d-m-Y";
		$aryFormat[] = "d-Y-m";
		$aryFormat[] = "y-m-d";
		$aryFormat[] = "y-d-m";
		$aryFormat[] = "Y-d-m";

		//Possible fields separators?
		$aryCharsToReplace[] = '\\';
		$aryCharsToReplace[] = '-';
		$aryCharsToReplace[] = '.';
		$aryCharsToReplace[] = ',';
		$aryCharsToReplace[] = ' ';

		//Max days for each month
		$aryMonthDayCount[1] = 31; //January
		$aryMonthDayCount[2] = 29; //February
		$aryMonthDayCount[3] = 31; //March
		$aryMonthDayCount[4] = 30; //April
		$aryMonthDayCount[5] = 31; //May
		$aryMonthDayCount[6] = 30; //June
		$aryMonthDayCount[7] = 31; //July
		$aryMonthDayCount[8] = 31; //August
		$aryMonthDayCount[9] = 30; //September
		$aryMonthDayCount[10] = 31; //October
		$aryMonthDayCount[11] = 30; //November 
		$aryMonthDayCount[12] = 31; //December

		$tmpdate = trim($tmpdate);
		
		//only seperator should be '-'
		foreach ( $aryCharsToReplace as $replaceme ) {
			$tmpdate = str_replace($replaceme, '/', $tmpdate);
		}
		
		$aryDate =  explode('/', $tmpdate);
		
		if ( count($aryDate) > 3 ) {
			$this->SetError("Too many fields in date(".$date.")!");
			return(false);
		}

		//just to check
		foreach ( $aryDate as $val ) {
			if ( !is_numeric($val) ) {
				$this->SetError("Non-numeric values in date (".$date.")!");
				return(false);
			}
			if ( strlen($val) == 3 || strlen($val) > 4 ) {
				$this->SetError("Suspicious digit count in date (".$date.")!");
				return(false);
			}
			
		}

		//Process of elimination:
		//******************************************************************
		//Months...
		if ( $aryDate[0] > 12 ) {
			$this->DeleteArrayValueItem($aryFormat, "m-d-y");	
			$this->DeleteArrayValueItem($aryFormat, "m-y-d");	
			$this->DeleteArrayValueItem($aryFormat, "m-d-Y");	
			$this->DeleteArrayValueItem($aryFormat, "m-Y-d");	
		}
		if ( $aryDate[1] > 12 ) {
			$this->DeleteArrayValueItem($aryFormat, "d-m-y");	
			$this->DeleteArrayValueItem($aryFormat, "y-m-d");	
			$this->DeleteArrayValueItem($aryFormat, "d-m-Y");	
			$this->DeleteArrayValueItem($aryFormat, "Y-m-d");	
		}	
		if ( $aryDate[2] > 12 ) {
			$this->DeleteArrayValueItem($aryFormat, "y-d-m");	
			$this->DeleteArrayValueItem($aryFormat, "d-y-m");	
			$this->DeleteArrayValueItem($aryFormat, "Y-d-m");	
			$this->DeleteArrayValueItem($aryFormat, "d-Y-m");	
		}
		//Days...
		if ( $aryDate[0] > 31 ) {
			$this->DeleteArrayValueItem($aryFormat, "d-m-y");	
			$this->DeleteArrayValueItem($aryFormat, "d-y-m");	
			$this->DeleteArrayValueItem($aryFormat, "d-m-Y");	
			$this->DeleteArrayValueItem($aryFormat, "d-Y-m");	
		}
		if ( $aryDate[1] > 31 ) {
			$this->DeleteArrayValueItem($aryFormat, "m-d-y");	
			$this->DeleteArrayValueItem($aryFormat, "y-d-m");	
			$this->DeleteArrayValueItem($aryFormat, "m-d-Y");	
			$this->DeleteArrayValueItem($aryFormat, "Y-d-m");	
		}	
		if ( $aryDate[2] > 31 ) {
			$this->DeleteArrayValueItem($aryFormat, "y-m-d");	
			$this->DeleteArrayValueItem($aryFormat, "m-y-d");	
			$this->DeleteArrayValueItem($aryFormat, "Y-m-d");	
			$this->DeleteArrayValueItem($aryFormat, "m-Y-d");	
		}
		//4 digit year check
		if ( strlen($aryDate[0]) == 4 ) {
			$this->DeleteArrayValueItem($aryFormat, "m-d-y");
			$this->DeleteArrayValueItem($aryFormat, "m-y-d");
			$this->DeleteArrayValueItem($aryFormat, "m-d-Y");
			$this->DeleteArrayValueItem($aryFormat, "m-Y-d");
			$this->DeleteArrayValueItem($aryFormat, "d-m-y");
			$this->DeleteArrayValueItem($aryFormat, "d-y-m");
			$this->DeleteArrayValueItem($aryFormat, "d-m-Y");
			$this->DeleteArrayValueItem($aryFormat, "d-Y-m");
			$this->DeleteArrayValueItem($aryFormat, "y-m-d");
			$this->DeleteArrayValueItem($aryFormat, "y-d-m");
		}
		if ( strlen($aryDate[1]) == 4 ) {
			$this->DeleteArrayValueItem($aryFormat, "m-d-y");
			$this->DeleteArrayValueItem($aryFormat, "m-y-d");
			$this->DeleteArrayValueItem($aryFormat, "m-d-Y");
			$this->DeleteArrayValueItem($aryFormat, "d-m-y");
			$this->DeleteArrayValueItem($aryFormat, "d-y-m");
			$this->DeleteArrayValueItem($aryFormat, "d-m-Y");
			$this->DeleteArrayValueItem($aryFormat, "y-m-d");
			$this->DeleteArrayValueItem($aryFormat, "y-d-m");
			$this->DeleteArrayValueItem($aryFormat, "Y-m-d");
			$this->DeleteArrayValueItem($aryFormat, "Y-d-m");
		}	
		if ( strlen($aryDate[2]) == 4 ) {
			$this->DeleteArrayValueItem($aryFormat, "m-d-y");
			$this->DeleteArrayValueItem($aryFormat, "m-y-d");
			$this->DeleteArrayValueItem($aryFormat, "m-Y-d");
			$this->DeleteArrayValueItem($aryFormat, "d-m-y");
			$this->DeleteArrayValueItem($aryFormat, "d-y-m");
			$this->DeleteArrayValueItem($aryFormat, "d-Y-m");
			$this->DeleteArrayValueItem($aryFormat, "y-m-d");
			$this->DeleteArrayValueItem($aryFormat, "y-d-m");
			$this->DeleteArrayValueItem($aryFormat, "Y-m-d");
			$this->DeleteArrayValueItem($aryFormat, "Y-d-m");
		}	
		if ( strlen($aryDate[0]) != 4 ) {
			$this->DeleteArrayValueItem($aryFormat, "Y-m-d");
			$this->DeleteArrayValueItem($aryFormat, "Y-d-m");
		}
		if ( strlen($aryDate[1]) != 4 ) {
			$this->DeleteArrayValueItem($aryFormat, "d-Y-m");
			$this->DeleteArrayValueItem($aryFormat, "m-Y-d");
		}
		if ( strlen($aryDate[2]) != 4 ) {
			$this->DeleteArrayValueItem($aryFormat, "d-m-Y");
			$this->DeleteArrayValueItem($aryFormat, "m-d-Y");
		}
		//Check for year digit counts
		foreach ( $aryFormat as $val ) {
	
		}
		
		//Check for per month maximum days.
		foreach ( $aryFormat as $val ) {
			
			//Make sure we can get the correct values	
			$day = $this->GetDay($aryDate, $val);
			if (!$day){return(false);}
			$month = $this->GetMonth($aryDate,$val);
			if (!$month){return(false);}
			
			//if ( DayOfMonth is greaterthan MaxDaysInMonth ) {
			if ( $day > $aryMonthDayCount[$month]  ){
				$this->DeleteArrayValueItem($aryFormat, $val);
			}
		}

		//Leap year Check
		foreach ( $aryFormat as $val ) {
			
			//Make sure we can get the correct values	
			$month = $this->GetMonth($aryDate, $val);
			if (!$month){return(false);}
			$day = $this->GetDay($aryDate, $val);
			if (!$day){return(false);}
			
			if ( $month == 2 && $day == 29 ) {
				//Start figuring out if year is a leap year
				$bLeap = False;
				
				$iYear = $this->GetYear($aryDate, $val);
				$iYear = $this->GuessCentury($iYear);
				
				//Divisible by 4 rule
				if ( ($iYear % 4) == 0 ) {
					//Divisible by 100 rule:
					if ( ( $iYear % 100) == 0 ) {
						//Divisible by 400 rule:
						if ( ( $iYear % 400) == 0 ) {
							$bLeap = True;
						}	
					} else {	
						$bLeap = True;
					}
				}

				if ( !$bLeap ) {	
					$this->DeleteArrayValueItem($aryFormat, $val);
				}
			}
		}
		
		// start: Comment this out
		//echo "Surviving Formats:\n";
		//foreach ( $aryFormat as $val ) {
		//		echo "\t\t$val\n";
		//}
		// end: Comment this out
		
		//If any formats survived the cut, it can be viewed as a valid date
		if ( count($aryFormat) > 0 ) {
			$this->SetFormatedDate($aryDate, $aryFormat[0]);
			return(true);
		} else {
			$this->SetError("Date fits no acceptable format.");
			return(false);
		}
		
	}
	function GetDay($aryDate, $sFormat) {
		
		if ( strpos($sFormat, "d") !== false ) {
			switch (strpos($sFormat, "d")) {
				case (0):
					$return = $aryDate[0];		
					break;
				case (2):
					$return = $aryDate[1];		
					break;
				case (4):
					$return = $aryDate[2];		
					break;
				default:
					$this->SetError("Error in CDateValidator::GetDay");	
					return(false);
			}
		}
		return((int)$return);
	}
	function GetMonth($aryDate, $sFormat) {
		
		if ( strpos($sFormat, "m") !== false ) {
			switch (strpos($sFormat, "m")) {
				case (0):
					$return = $aryDate[0];		
					break;
				case (2):
					$return = $aryDate[1];		
					break;
				case (4):
					$return = $aryDate[2];		
					break;
				default:
					$this->SetError("Error in CDateValidator::GetMonth");	
					return(false);
			}
		}
		return((int)$return);
	}
	//Currently not used
	function GetYear($aryDate, $sFormat) {
		if ( strpos(strtolower($sFormat), "y") !== false ) {
			switch (strpos(strtolower($sFormat), "y")) {
				case (0):
					$return = $aryDate[0];		
					break;
				case (2):
					$return = $aryDate[1];		
					break;
				case (4):
					$return = $aryDate[2];		
					break;
				default:
					$this->SetError("Error in CDateValidator::GetYear");	
					return(false);
			}
		}

		return((int)$return);
	}

	function GuessCentury($iYear) {
		//if they only entered 2 digits, do some guess work for the century
		if ( strlen((string)$iYear) == 2 || strlen((string)$iYear) == 1 ) {
			if ( $iYear > 30 ) {
				$iYear += 1900;
			} else {
				$iYear += 2000;
			}
		}
		return($iYear);
	}

	
	function DeleteArrayValueItem(&$ary, $sValue) {
		$aryNew=array();
		foreach ( $ary as $key=>$val ) {
			if ( $val != $sValue ) {
				$aryNew[] = $val;
			}
		}
		$ary = $aryNew;	
	}
	
	function PadSingleDigits($sData) {
		if ( strlen($sData) == 1 ) {
			return("0".$sData);
		} else { 
			return($sData);
		}
	}

}//CDateValidator
?>
